<?php

declare(strict_types=1);

namespace Dedi\SyliusMailAdminPlugin\EventListener\MailAdmin;

use Dedi\SyliusMailAdminPlugin\Event\DediMailAdminEvent;
use Sylius\Bundle\UserBundle\Mailer\Emails;
use Sylius\Component\User\Model\UserInterface;
use Symfony\Bundle\FrameworkBundle\Routing\Router;
use Symfony\Component\Routing\RouterInterface;

class ResetPasswordTokenPreRendererListener
{
    private RouterInterface $router;

    public function __construct(RouterInterface $router)
    {
        $this->router = $router;
    }

    public function __invoke(DediMailAdminEvent $event): DediMailAdminEvent
    {
        if (Emails::RESET_PASSWORD_TOKEN !== $event->getEmail()->getCode()) {
            return $event;
        }

        $data = $event->getData();
        /** @var UserInterface $user */
        $user = $data['user'];

        $data['resetUrl'] = $this->router->generate('sylius_shop_password_reset', [
            'token' => $user->getPasswordResetToken(),
        ], Router::ABSOLUTE_URL);

        $event->setData($data);

        return $event;
    }
}
